
/*
  Lithium 0.1

  Copyright (C) 2001 Teti Paolo.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  (LICENSE file) along with this program; if not, write to
  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
/**
 * Loop.java
 *
 *
 *
 *
 * @author Paolo Teti
 * @version 0.1
 */


package lithium2;

import java.lang.Integer;

public class Loop extends JSkeletons
{
    JSkeletons loopWorker = null;
    int numIteration = 0;



    /**
     * The Loop Skeleton
     *
     * @param loopWorker The skelton to be executed.
     * @param n Number of iteration.
     */
    public Loop(JSkeletons loopWorker, int n)
    {
	this.loopWorker = loopWorker;
	numIteration = n;
    }



    Object[] getSkeletonInfo()
    {
	Object [] retValue = new Object[2];
	// Numero di iterazioni
	retValue[0] = new Integer(numIteration);
	// Skeleton incapsulato
	retValue[1] = loopWorker;
	return (retValue);
    }



    public Object run (Object task)
    {
	Object actualTask = task;

	for (int k=0;k<numIteration;k++)
	    actualTask = loopWorker.run(actualTask);

	return (actualTask);
    }



} // Loop


